	INCLUDE EFR32MG12.inc		; CPU register definitions
	INCLUDE terminal.inc		; terminal function definitions		
	EXPORT	main
		
;-------------------------------------	; CODE segment in flash (ROM) 
	AREA    |.text|, CODE, READONLY
main	PROC				; main user code
	bl	Terminal_setup		; setup TeraTerm communication

loop					; periodic task starts here
	ldr	R0, =prompt1
	bl	WriteString
	bl	ReadInt	
	mov	R1, R0			; R1 = 1st number
	
	ldr	R0, =prompt2
	bl	WriteString
	bl	ReadInt			; R0 = 2nd number

	bl	GCD			; R0 = GCD(R0, R1)

	push	{R0}			; save R0 in stack
	ldr	R0, =prompt3		; print the answer
	bl	WriteString
	pop	{R0}			; restore R0
	
	bl	WriteInt		; print GCD
	bl	NewLine
	bl	NewLine

	b	loop			; repeat periodic task		
	ENDP

;-------------------------------------
GCD	PROC				; computes R0 = GCD(R0, R1)
	push	{LR, R1, R2}		; save used regs
L1	cbz	R1, L2			; all done?
	udiv	R2, R0, R1		; R2 = a/b
	mls	R2, R2, R1, R0		; R2 = a%b
	mov	R0, R1
	mov	R1, R2
	b	L1

L2	pop	{PC, R1, R2}		; restore used regs and exit	
	ENDP
		
;-------------------------------------
prompt1	DCB	"Enter 1st number: ", 0	
prompt2	DCB	"Enter 2nd number: ", 0
prompt3	DCB	"GCD = ", 0

	ALIGN
	END